﻿    using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms;

namespace TreeCustom
{
    public partial class Form1 : MetroForm
    {
        public Form1()
        {
            InitializeComponent();
            this.treeViewAdv1.Style = TreeStyle.Metro;
        }
        
        GridGroupingControl GridGroup;
        GridGroupingControl GridGroupForParticularNode;
        TreeNodeAdv TreeNode;
        int nodenumber = 0;
       

        //Used to iterate through all the nodes.
        IEnumerable<TreeNodeAdv> Collect(TreeNodeAdvCollection nodes)
        {
            foreach (TreeNodeAdv node in nodes)
            {
                yield return node;

                foreach (var child in Collect(node.Nodes))
                    yield return child;
            }
        }
        // Create a DataTable. 
        DataTable dt = new DataTable("Table1");
        DataTable TableForParticularNode = new DataTable("PaticularNodeTable");
        private void Form1_Load(object sender, EventArgs e)
        {            
            // Adding Columns.
            dt.Columns.Add("FirstName"); 
            dt.Columns.Add("LastName");
            dt.Columns.Add("occupation");
            dt.Columns.Add("place");

            // Create a Data Set. 
            DataSet ds = new DataSet();
            ds.Tables.Add(dt); 
            dt.Rows.Add(new string[] { "John", "Tina", "Doctor", "Italy" }); 
            dt.Rows.Add(new string[] { "Mary", "anu", "Teacher", "America" });
            dt.Rows.Add(new string[] { "asha", "roy", "Staff", "London" }); 
            dt.Rows.Add(new string[] { "George", "Gaskin", "Nurse", "germany" }); 
            dt.Rows.Add(new string[] { "sam", "jens", "Engineer", "Russia" }); 
            dt.Rows.Add(new string[] { "Ben", "Geo", "Developer", "India" });

            int i = 0;
            int TotalNodeCount = 4;
            //To add the Parent node
            for (i = 0; i < TotalNodeCount; i++)
            {
                TreeNode = new TreeNodeAdv();
                TreeNode.Text = "node" + nodenumber.ToString();
                nodenumber++;
                this.treeViewAdv1.Nodes.Add(TreeNode);
            }

            //To Add child node
            foreach (TreeNodeAdv node in this.treeViewAdv1.Nodes)
            {
                for (int childnode = 0; childnode <= 30; childnode++)
                {
                    TreeNode = new TreeNodeAdv();
                    TreeNode.Text = "node" + nodenumber.ToString();
                    nodenumber++;
                    node.Nodes.Add(TreeNode);
                }
            }

            for (int addcustom = 0; addcustom < this.treeViewAdv1.Nodes.Count; addcustom++)
            {
                //To add the GridGrouping Control.
                foreach (TreeNodeAdv node in Collect(this.treeViewAdv1.Nodes[addcustom].Nodes))
                {
                    GridGroup = new GridGroupingControl();

                    GridGroup.GridVisualStyles = GridVisualStyles.Metro;
                    GridGroup.TopLevelGroupOptions.ShowCaption = false;
                    if (node.CustomControl == null)
                    {
                        node.CustomControl = GridGroup;
                        GridGroup.DataSource = dt;
                        node.CustomControl.Width = 300;
                        node.Height = 80;
                    }
                }
            }

            // Adding Columns.
            TableForParticularNode.Columns.Add("FirstName");
            TableForParticularNode.Columns.Add("LastName");
            TableForParticularNode.Columns.Add("PhoneNumber");
            TableForParticularNode.Columns.Add("Country");

            TableForParticularNode.Rows.Add(new string[] { "Ricky", "Tina", "12312314", "Italy" });
            TableForParticularNode.Rows.Add(new string[] { "Mical", "anu", "12314123", "America" });
            TableForParticularNode.Rows.Add(new string[] { "Rani", "roy", "234234", "London" });
            TableForParticularNode.Rows.Add(new string[] { "Krish", "Gaskin", "24342341231", "germany" });

            this.treeViewAdv1.Nodes[3].Nodes[0].CustomControl = null;
            GridGroupForParticularNode = new GridGroupingControl();
            GridGroupForParticularNode.GridVisualStyles = GridVisualStyles.Metro;
            GridGroupForParticularNode.TopLevelGroupOptions.ShowCaption = false;
            if (this.treeViewAdv1.Nodes[3].Nodes[0].CustomControl == null)
            {
                this.treeViewAdv1.Nodes[3].Nodes[0].CustomControl = GridGroupForParticularNode;
                GridGroupForParticularNode.DataSource = TableForParticularNode;
                this.treeViewAdv1.Nodes[3].Nodes[0].CustomControl.Width = 300;
                this.treeViewAdv1.Nodes[3].Nodes[0].Height = 80;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.listBox1.Items.Clear();
            foreach (DataRow dr in ((this.treeViewAdv1.Nodes[3].Nodes[0].CustomControl as GridGroupingControl).DataSource as DataTable).Rows)
            {
                //dr["place"].ToString();
                this.listBox1.Items.Add(dr["FirstName"].ToString());
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.listBox1.Items.Clear();
            if (this.treeViewAdv1.SelectedNode != null && this.treeViewAdv1.SelectedNode.CustomControl != null)
            {
                //To get the DataTable from GridGroupingControl.
                foreach (DataRow dr in ((this.treeViewAdv1.SelectedNode.CustomControl as GridGroupingControl).DataSource as DataTable).Rows)
                {
                    //To get the Row value from DataTable.
                    this.listBox1.Items.Add(dr["FirstName"].ToString());
                }
            }
        }

    }
}
